/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.chaubold.math;

/**
 *
 * @author caste
 */
public class Vec2 {
    public float x = 0.0f, y = 0.0f;

    /** Simply creates instance, components initialised to
    <tt>(float)0.0</tt> */
    public Vec2() {
        //vector already set to (0.0,0.0,0.0)
    }

    public Vec2(Vec2 a) {
        x = a.x;
        y = a.y;
    }

    public Vec2(float xx1, float xx2) {
        x = xx1;
        y = xx2;
    }

    public void setValue(float xx1, float xx2) {
        x = xx1;
        y = xx2;
    }

    public void setValue(Vec2 a) {
        x = a.x;
        y = a.y;
    }

    /** Sets <tt>Vec2 this</tt> to zero */
    public void setZero() {
        x = (float) 0.0;
        y = (float) 0.0;
    }

    public Vec2 add(Vec2 a) {
        return new Vec2(x + a.x, y + a.y);
    }

    public Vec2 sub(Vec2 a) {
        return new Vec2(x - a.x, y - a.y);
    }

    public static float dot(Vec2 a, Vec2 b) {
        return (a.x * b.x + a.y * b.y);
    }

    public Vec2 normalize() {
        Vec2 out = new Vec2();
        float length;
        length = length();
        out.x = x / length;
        out.y = y / length;
        return out;
    }

    /** Returns length of vector */
    public float length() {
        return ((float) Math.sqrt(x * x + y * y));
    }

    /** Returns length of vector squared */
    public float lengthSqr() {
        return (x * x + y * y);
    }

    /** Returns length of vector (b-a) squared */
    public static float distSqr(Vec2 a, Vec2 b) {
        return ((float) (a.x - b.x) * (a.x - b.x) +
                (a.y - b.y) * (a.y - b.y));
    }

    public Vec2 mult(float a)
    {
        return new Vec2(a*x, a*y);
    }
}
