/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.chaubold.math;

/**
 *
 * @author caste
 */
public class Vec4 {

    public float x = 0.0f,  y = 0.0f,  z = 0.0f, w = 0.0f;

    /** Simply creates instance, components initialised to
    <tt>(float)0.0</tt> */
    public Vec4() {
        //vector already set to (0.0,0.0,0.0)
    }

    public Vec4(Vec4 a) {
        x = a.x;
        y = a.y;
        z = a.z;
        w = a.w;
    }

    public Vec4(float xx1, float xx2, float xx3, float xx4) {
        x = xx1;
        y = xx2;
        z = xx3;
        w = xx4;
    }

    public void setValue(float xx1, float xx2, float xx3, float xx4) {
        x = xx1;
        y = xx2;
        z = xx3;
        w = xx4;
    }

    public void setValue(Vec4 a) {
        x = a.x;
        y = a.y;
        z = a.z;
        w = a.w;
    }

    /** Sets <tt>Vec3 this</tt> to zero */
    public void setZero() {
        x = (float) 0.0;
        y = (float) 0.0;
        z = (float) 0.0;
        w = 0.0f;
    }

    public Vec4 add(Vec4 a) {
        return new Vec4(x + a.x, y + a.y, z + a.z, w + a.w);
    }

    public Vec4 sub(Vec4 a) {
        return new Vec4(x - a.x, y - a.y, z - a.z, w - a.w);
    }

    public static float dot(Vec4 a, Vec4 b) {
        return (a.x * b.x + a.y * b.y + a.z * b.z + a.w * b.w);
    }

    public Vec4 normalize() {
        Vec4 out = new Vec4();
        float length;
        length = length();
        out.x = x / length;
        out.y = y / length;
        out.z = z / length;
        return out;
    }

    /** Returns length of vector */
    public float length() {
        return ((float) Math.sqrt(x * x + y * y + z * z + w * w));
    }

    /** Returns length of vector squared */
    public float lengthSqr() {
        return (x * x + y * y + z * z + w * w);
    }

     public Vec4 mult(float a)
    {
        return new Vec4(a*x, a*y, a*z, a*w);
    }
}
