/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.chaubold.physicstest;

import android.app.Activity;

import android.content.pm.ActivityInfo;
import android.hardware.SensorListener;
import android.hardware.SensorManager;
import android.opengl.GLSurfaceView;
import android.os.Bundle;
import de.chaubold.math.Vec3;


/**
 *
 * @author amit
 */
public class MainActivity extends Activity implements SensorListener {

    private GLSurfaceView m_GLSurfaceView;
    private SceneRenderer m_Renderer;
    private SensorManager m_SensorManager;
    private float[] m_gravity = new float[3];
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        m_Renderer = new SceneRenderer(true, this.getResources());

        m_SensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);

        // Activity
        m_GLSurfaceView = new GLSurfaceView(this);

        m_GLSurfaceView.setRenderer(m_Renderer);
        setContentView(m_GLSurfaceView);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);
    }

    @Override
    protected void onPause() {
        // Ideally a game should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onPause();
        m_GLSurfaceView.onPause();
    }
   
    public void onAccuracyChanged(int arg0, int arg1) {
        //do nothing
    }

    @Override
    protected void onResume() {
        super.onResume();
        m_GLSurfaceView.onResume();
        m_SensorManager.registerListener(this, SensorManager.SENSOR_ACCELEROMETER |
                SensorManager.SENSOR_MAGNETIC_FIELD |
                SensorManager.SENSOR_ORIENTATION, SensorManager.SENSOR_DELAY_FASTEST);
    }

    @Override
    protected void onStop() {
        m_SensorManager.unregisterListener(this);
        super.onStop();
    }

    public void onSensorChanged(int sensor, float[] values) {
        //handle sensor inputs
        if (sensor == SensorManager.SENSOR_ACCELEROMETER) {
            m_gravity[0] = values[0];
            m_gravity[1] = values[1];
            m_gravity[2] = values[2];
            m_Renderer.setGravityVector(new Vec3(m_gravity[0], m_gravity[1], m_gravity[2]));
        }
    }

}
