/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.chaubold.physicstest.physic;

import de.chaubold.math.Vec2;

/**
 *
 * @author caste
 */
public class Constraint {
    Particle _p1, _p2;
    float _length, _stiffness;
    private final float _threshold = 0.05f;

    public Constraint(Particle p1, Particle p2, float length, float stiffness)
    {
        _p1 = p1;
        _p2 = p2;
        _length = length;
        _stiffness = stiffness;
    }

    public Constraint(Particle p1, Particle p2, float stiffness)
    {
        _p1 = p1;
        _p2 = p2;
        _length = _p1._position.sub(_p2._position).length();
        _stiffness = stiffness;
    }

    public Constraint(Particle p1, Particle p2)
    {
        _p1 = p1;
        _p2 = p2;
        _length = _p1._position.sub(_p2._position).length();
        _stiffness = 1.0f;
    }

    void update()
    {
        Vec2 delta = _p1._position.sub(_p2._position);
        float currLength = delta.length();
        float diff = (currLength - _length);

        if(Math.abs(diff) > _threshold && currLength != 0.0f)
        {
            diff /= currLength;
            delta = delta.mult(diff*0.5f*_stiffness);

            _p1._position.setValue(_p1._position.sub(delta));
            _p2._position.setValue(_p2._position.add(delta));
        }
    }
}
