/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.chaubold.physicstest.physic;

import de.chaubold.math.Vec2;

/**
 *
 * @author caste
 */
public class Particle {

    Vec2 _position, _oldPosition, _acceleration;
    System _system;

    public Particle(Vec2 position, System sys) {
        _position = position;
        _system = sys;
        _oldPosition = new Vec2(_position);
        _acceleration = new Vec2(0.0f, 0.0f);
    }

    public void update(float dT) {
        Vec2 temp = new Vec2(_position);
        _position.setValue(_position.add(_position.sub(_oldPosition)).add(_acceleration.mult(dT * dT * 0.5f)));

        if (_position.x > 0.5f * _system._worldDimension.x) {
            _position.x = 0.5f * _system._worldDimension.x;
            _oldPosition.x = _position.x;
        }
        if (_position.x < -0.5f * _system._worldDimension.x) {
            _position.x = -0.5f * _system._worldDimension.x;
            _oldPosition.x = _position.x;
        }
        if (_position.y > 0.5f * _system._worldDimension.y) {
            _position.y = 0.5f * _system._worldDimension.y;
            _oldPosition.y = _position.y;
        }
        if (_position.y < -0.5f * _system._worldDimension.y) {
            _position.y = -0.5f * _system._worldDimension.y;
            _oldPosition.y = _position.y;
        }

        _oldPosition.setValue(temp);

        //other forces can be added by constraints etc now
        _acceleration = _system._gravity;
    }
}
