/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.chaubold.physicstest.physic;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import javax.microedition.khronos.opengles.GL10;

/**
 *
 * @author caste
 */
public class SystemRenderer {
    System _system;

    private void CheckError(GL10 gl, String debug) {
        if (gl.glGetError() != gl.GL_NO_ERROR) {
            java.lang.System.out.println("Error at " + debug);
        }
    }

    public SystemRenderer(System sys)
    {
        _system = sys;
    }

    public void drawParticles(GL10 gl)
    {
        gl.glColor4f(1.0f,1.0f,1.0f, 1.0f);

        //Allocate enough bytes to store all our floats -> 3 floats per particle, 4 bytes per float
        ByteBuffer vbb = ByteBuffer.allocateDirect(_system._particles.size()*3*4);
        vbb.order(ByteOrder.nativeOrder());
		FloatBuffer vertices=vbb.asFloatBuffer();
		for(int x=0;x<_system._particles.size();x++)
		{
			vertices.put(x*3+0,_system._particles.get(x)._position.x);
			vertices.put(x*3+1,_system._particles.get(x)._position.y);
            vertices.put(x*3+2, 0.0f);
		}

        vertices.position(0);

        //Draw the Particles with OpenGL
        gl.glEnableClientState(gl.GL_VERTEX_ARRAY);
		gl.glVertexPointer(3,GL10.GL_FLOAT, 0, vertices);

		gl.glDrawArrays(gl.GL_POINTS,0,_system._particles.size());

		gl.glDisableClientState(gl.GL_VERTEX_ARRAY);
        CheckError(gl, "Draw Particles");
    }

    public void drawConstraints(GL10 gl)
    {
        gl.glColor4f(1.0f,0.0f,0.0f,1.0f);

        //Allocate enough bytes to store all our floats -> 6 floats per constraint, 4 bytes per float
        ByteBuffer vbb = ByteBuffer.allocateDirect(_system._constraints.size()*6*4);
        vbb.order(ByteOrder.nativeOrder());
		FloatBuffer vertices=vbb.asFloatBuffer();
		for(int x=0;x<_system._constraints.size();x++)
		{
			vertices.put(x*6+0,_system._constraints.get(x)._p1._position.x);
			vertices.put(x*6+1,_system._constraints.get(x)._p1._position.y);
            vertices.put(x*6+2, 0.0f);
            vertices.put(x*6+3,_system._constraints.get(x)._p2._position.x);
			vertices.put(x*6+4,_system._constraints.get(x)._p2._position.y);
            vertices.put(x*6+5, 0.0f);
		}

        vertices.position(0);

        //Draw the Particles with OpenGL
        gl.glEnableClientState(gl.GL_VERTEX_ARRAY);
		gl.glVertexPointer(3,GL10.GL_FLOAT, 0, vertices);

		gl.glDrawArrays(gl.GL_LINES,0,_system._constraints.size()*2);

		gl.glDisableClientState(gl.GL_VERTEX_ARRAY);
        CheckError(gl, "Draw Particles");
    }
}
